--Laser Gun example mod

function init()
	--Register tool and enable it
	RegisterTool("NUKE_REMOTE", "nuke remote", "MOD/magicdaggertool.vox")
	SetBool("game.tool.NUKE_REMOTE.enabled", true)
	throw = LoadSound("MOD/throw.ogg")
	dumb = LoadSound("MOD/dumb.ogg")
	boom = LoadSound("MOD/boom.ogg")
	tim = 0
	--wrongversion = true
end

--Return a random vector of desired length
function rndVec(length)
	local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
	return VecScale(v, length)	
end

function tick(dt)
	--a = GetPlayerCameraTransform()
	--local offset = Transform(Vec(a.pos[1], a.pos[2] - 0.6, a.pos[3]))
	--SetToolTransform(offset)
	--Check if laser gun is selected
	if GetString("game.player.tool") == "NUKE_REMOTE" then
	
		--Check if tool is firing
		if GetBool("game.player.canusetool") and InputPressed("usetool") then
			--wrongversion = true
			--if wrongversion then
			--	PlaySound(dumb)
			--	PlaySound(boom)
			--	DebugPrint("")
			--end

			DebugPrint(GetVersion())
			if not HasVersion("0.9.0") then
				wrongversion = true
				PlaySound(dumb)
				PlaySound(boom)
			end
			--wrongversion = true
			--for i=1,15 do

			if not wrongversion then
			local ct = GetCameraTransform()
			local startpos = TransformToParentPoint(ct, Vec(0, 0, -1))
			--local grenade = Spawn("MOD/holygrenade.xml", Transform(startpos))
			local fwdpos = TransformToParentPoint(ct, Vec(0, 0, -40))
			local direction = VecSub(fwdpos, startpos)
			--SetBodyVelocity(grenade[1], direction)
			tim = tim + dt

			playertrans = GetPlayerTransform()
			x,y,z = GetQuatEuler(playertrans.rot)
			playertrans.rot = QuatEuler(x,y+180,z)

			if tim > 0 then
				PlaySound(throw)
			Spawn("MOD/NUKE.xml", Transform(GetAimPos(), playertrans.rot))
			tim = 0
			end
		end
		--end
		end
	end
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -100))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function draw()
	if GetString("game.player.tool") == "NUKE_REMOTE" and wrongversion then
		UiImageBox("MOD/getgood.png", UiWidth(), UiHeight(), 10, 10)
	end
	end