_G.RGLSICD_Version = "6.72" -- Must be a string, numbers are perishable and volitile.

local TextPosition = -400
local SliderPosition = 150
local Version = _G.RGLSICD_Version
local NewUpdate = ""
local UT = Version.." is out. "

if GetInt("savegame.mod.shockwave_speed") < 2 then
			SetInt("savegame.mod.shockwave_strength",100)
			SetInt("savegame.mod.shockwave_damage",100)
			SetInt("savegame.mod.shockwave_speed",100)
			SetInt("savegame.mod.shockwave_quality",100)
			SetInt("savegame.mod.heatwave_quality",100)
			SetInt("savegame.mod.heatwave_damage",100)
			SetInt("savegame.mod.explosion_brightness",100)
		end

function PopulateOptions(force)
	local SV = GetString("savegame.mod.savegame_version")
	if (force == true) or (SV ~= Version) then
		if (SV == nil) or (#SV == 0) then
			SV = 0
		else
			SV = tonumber(SV) or 0
		end
		SetString("savegame.mod.savegame_version",Version)
		if (force == true) or (SV == 0) then
			if (force ~= true) then
				--NewUpdate = "Welcome to SICD! Please configure your options below."
			else
				NewUpdate = "Settings have been reset to default."
			end
			--SetBool("savegame.mod.showdestruction",false)
			--SetBool("savegame.mod.performancesystem",true)
		elseif (SV < 6.70) then
			NewUpdate = UT.."Performance System: Toggles on or off the Performance System. Minimal to Moderate CPU usage reduction when enabled."
			SetBool("savegame.mod.performancesystem",true)
		end
	end
end

function optionsSlider(key,min,max)
	UiPush()
		UiTranslate(min,-8)
		local rv = GetInt(key)
		if (rv > max) then
			SetInt(key,max)
			rv = max
		elseif (rv < min) then
			SetInt(key,min)
			rv = min
		end
		UiRect(max-min,3)
		UiAlign("center middle")
		UiTranslate(-min,-8)
		local nsv,done = UiSlider("ui/common/dot.png","x",rv,min,max)
		if (nsv ~= rv) then
			if (nsv == 0) then
				SetInt(key,1) -- Cannot be zero.
			else
				SetInt(key,nsv)
			end
		end
	UiPop()
	return rv,max
end

function draw()
	PopulateOptions(false)
	
	UiTranslate(UiCenter(),140)
	UiAlign("center middle")
	UiFont("bold.ttf",48)
	if (#NewUpdate > 0) then
		UiTranslate(0,-100)
		UiColor(1,1,0)
		UiText("There are settings to configure!")
		UiColor(1,1,1)
		UiTranslate(0,50)
		UiFont("regular.ttf",26)
		UiText(NewUpdate)
		UiTranslate(0,50)
		UiFont("bold.ttf",48)
	end
	--Title
	UiText("Please help me this isnt a joke, theres a man in my walls and hes coming for me, oh god he is hungry")
	
	UiTranslate(0,10)
	UiFont("regular.ttf",26)
	UiPush()
		local OFS = 100
		UiTranslate(TextPosition-OFS,50)
		UiText("Shockwave strength")
		UiAlign("left")
		UiTranslate(SliderPosition+OFS,8)
		local CurVal,MaxVal = optionsSlider("savegame.mod.shockwave_strength",1,1000)  -- SHOCKWAVE STRENGTH
		UiTranslate(MaxVal+20,0)
		UiText(tostring(CurVal).."/"..tostring(MaxVal))
	UiPop()
	UiPush()
		local OFS = 20
		UiTranslate(TextPosition-OFS,25)
		UiText("Shockwave damage")
		UiAlign("left")
		UiTranslate(SliderPosition+OFS,8)
		local CurVal,MaxVal = optionsSlider("savegame.mod.shockwave_damage",1,500) -- SHOCKWAVE DAMAGE
		UiTranslate(MaxVal+20,0)
		UiText(tostring(CurVal).."/"..tostring(MaxVal))
	UiPop()
	UiTranslate(0,75)
	
	UiPush()
		local OFS = 14
		UiTranslate(TextPosition-OFS,10)
		UiText("Shockwave speed")
		UiAlign("left")
		UiTranslate(SliderPosition+OFS,8)
		local CurVal,MaxVal = optionsSlider("savegame.mod.shockwave_speed",1,400) -- SHOCKWAVE SPEED
		UiTranslate(MaxVal+20,0)
		UiText(tostring(CurVal).."/"..tostring(MaxVal))
	UiPop()
	UiTranslate(0,75)

	UiPush()
		local OFS = 14
		UiTranslate(TextPosition-OFS,10)
		UiText("Radiation particles quality/amount")
		UiAlign("left")
		UiTranslate(SliderPosition+OFS,8)
		local CurVal,MaxVal = optionsSlider("savegame.mod.heatwave_quality",1,500) -- SHOCKWAVE SPEED
		UiTranslate(MaxVal+20,0)
		UiText(tostring(CurVal).."/"..tostring(MaxVal))
	UiPop()
	UiTranslate(0,75)

	UiPush()
		local OFS = 14
		UiTranslate(TextPosition-OFS,10)
		UiText("Shockwave particles life time")
		UiAlign("left")
		UiTranslate(SliderPosition+OFS,8)
		local CurVal,MaxVal = optionsSlider("savegame.mod.shockwave_quality",1,500) -- SHOCKWAVE SPEED
		UiTranslate(MaxVal+20,0)
		UiText(tostring(CurVal).."/"..tostring(MaxVal))
	UiPop()

	UiTranslate(0,75)

	UiPush()
		local OFS = 14
		UiTranslate(TextPosition-OFS,10)
		UiText("Explosion brightness")
		UiAlign("left")
		UiTranslate(SliderPosition+OFS,8)
		local CurVal,MaxVal = optionsSlider("savegame.mod.explosion_brightness",1,500) -- SHOCKWAVE SPEED
		UiTranslate(MaxVal+20,0)
		UiText(tostring(CurVal).."/"..tostring(MaxVal))
	UiPop()

	UiTranslate(0,75)

	UiPush()
		local OFS = 14
		UiTranslate(TextPosition-OFS,10)
		UiText("Radiation damage")
		UiAlign("left")
		UiTranslate(SliderPosition+OFS,8)
		local CurVal,MaxVal = optionsSlider("savegame.mod.heatwave_damage",1,500) -- SHOCKWAVE SPEED
		UiTranslate(MaxVal+20,0)
		UiText(tostring(CurVal).."/"..tostring(MaxVal))
	UiPop()
	
	-- Buttons
	--UiAlign("center")
	--UiTranslate(0,70)
	--UiButtonImageBox("ui/common/box-outline-6.png",6,6)
	--do
		--local utbv = GetBool("savegame.mod.performancesystem")
		--if UiTextButton("Toggle Performance System; Enabled: "..tostring(utbv),450,40) then
		--	SetBool("savegame.mod.performancesystem",not utbv)
		--end
	--end
	
	UiPush()
		UiTranslate(0,50)
		UiAlign("center")
		UiFont("regular.ttf",20)
		UiText("I ATE TOO MUCH TACOBELL MY BUTT HURT")
	UiPop()
end
